;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;														    ;
;			  	         MASTER-MIND pour Ash 3.0					    ;
;														    ;
;					 (c) 1997 Nicolas Hannebicque					    ;
;														    ;
;						nhannebi@ireste.fr					    ;
;														    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; dernire mise  jour : lundi 13 octobre 1997, 23 h 52
; tat : fonctionne trs bien (multiples "alpha" avant bien sr !!)

	#include	"ti82.h"
	#include	"oldcall.h"

	.org 	START_ADDR
	.db	"Master-Mind  by  Nick  N-bic",0

; allocation de la mmoire...

sorti0	=	TEXT_MEM		; sorti0 est  1 si le numro est pris par TI82, 0 sinon
sorti1	=	TEXT_MEM+1		;   "  1                    "
sorti2	=	TEXT_MEM+2		;   "  2                    "
sorti3	=	TEXT_MEM+3		; ...
sorti4	=	TEXT_MEM+4
sorti5	=	TEXT_MEM+5
sorti6	=	TEXT_MEM+6
sorti7	=	TEXT_MEM+7
pion1		=	TEXT_MEM+8		; mmorise dans pion1 le chiffre tir par TI82 lui correspondant
pion2		=	TEXT_MEM+9		;        "          2              "
pion3		=	TEXT_MEM+10		; ...
pion4		=	TEXT_MEM+11
pion5		=	TEXT_MEM+12
pion		=	TEXT_MEM+13		; sert plusieurs fois pour des variables temporaires
pion_joue1	=	TEXT_MEM+14		; mmorise dans pion_joue1 le chiffre jou par l'utilisateur,
pion_joue2	=	TEXT_MEM+15		; en l'occurence Toi (enfin j'espre :))
pion_joue3	=	TEXT_MEM+16		; etc...
pion_joue4	=	TEXT_MEM+17
pion_joue5	=	TEXT_MEM+18
bonne_coul	=	TEXT_MEM+19		; mmorise le nombre de bonnes couleurs ou chiffres sur TI82
bonne_place	=	TEXT_MEM+20		; mmorise le nombre de chiffres bien placs
coche0	=	TEXT_MEM+21		; analogue  sorti mais pour l'utilisateur
coche1	=	TEXT_MEM+22		; etc...
coche2	=	TEXT_MEM+23
coche3	=	TEXT_MEM+24
coche4	=	TEXT_MEM+25
coche5	=	TEXT_MEM+26
coche6	=	TEXT_MEM+27
coche7	=	TEXT_MEM+28
compteur	=	TEXT_MEM+29		; explicite ; il sert pour le nombre de coups jous
trucaaffich	=	TEXT_MEM+30		; "Truc  afficher" (sic) ; a a le mrite d'tre explicite
temoin	=	TEXT_MEM+31		; une variable tmoin, dans la fin du programme

; eh oui tout a. Ben ouais quand je vous dit que a n'est pas optimis !!

start:				; anglissisme courant :)
	ROM_CALL(BUSY_OFF)	; dsactive le bidule qui tourne  droite
	ld	a,$8C			; met la page de la ROM  4 pour permettre
	out	(2),a			; l'utilisation de FIND_PIXEL
	ROM_CALL(CLEARLCD)	; explicite je pense

	ld	hl,title_pic	; place l'adresse de l'cran de dpart en hl
	ld	de,GRAPH_MEM	;   "        "    de la mmoire graphique en de
	ld	bc,768		; met en bc le nombre d'octets  copier de hl  de
	ldir				; copie effectivement jusqu' bc=0
	ROM_CALL(DISP_GRAPH)	; affiche ce magnifique cran, dessin octet par octet  la main (sic)

	CALL_(attendre)		; la routine est  la fin. Explicite
	CALL_(faire_defiler)	; fait monter l'cran d'accueil

	ROM_CALL(CLEARLCD)	; no comment

	CALL_(dessine_ecran)	; affiche la routine de dessin de l'cran de jeu

	ld	b,5			; compteur b=5 (sert  la fin du tirage !!!)
	ld	a,0			; met 0 dans a
	ld	(sorti0),a		; charge tous les sorti  0, logique me diras-tu...
	ld	(sorti1),a
	ld	(sorti2),a
	ld	(sorti3),a
	ld	(sorti4),a
	ld	(sorti5),a
	ld	(sorti6),a
	ld	(sorti7),a
	ld	a,10			; met le comteur  10 (10 coups max :( => la prochaine version devrait
	ld	(compteur),a	; fonctionner avec la calculatrice pivote de PI/2 (pdent) pour avoir
					; plus de place...)

tirage:				; tire un nombre au hasard
	CALL_(Random)		; appelle le gnrateur de nombres alatoires
	cp	0			; compare le nombre tir  0 et le teste ensuite
	JUMP_Z(test0)		; voil donc il va  test0
	cp	1			; compare  1, etc...
	JUMP_Z(test1)
	cp	2
	JUMP_Z(test2)
	cp	3
	JUMP_Z(test3)
	cp	4
	JUMP_Z(test4)
	cp	5
	JUMP_Z(test5)
	cp	6			; NB: truc pour viter 1 instruction :
	JUMP_Z(test6)		; on ne teste pas le 7 !!!
test7:				; teste si le 7 est dj sorti
	ld	a,(sorti7)		; charge sorti7 en a
	cp	1			; le compare  1
	JUMP_Z(tirage)		; s'il est gal  1, retire un nombre
	ld	a,1			; sinon
	ld	(sorti7),a		; indique que le 7 est sorti
	ld	a,7			; met 7
	ld	(pion),a		; dans pion
	JUMP_(mise_en_mem)	; va  la phase de mise en mmoire (facile, vu le nom)
test6:				; tu veux que j'te l'explique c'lui l p'ttre ???
	ld	a,(sorti6)		; etc donc...
	cp	1
	JUMP_Z(tirage)
	ld	a,1
	ld	(sorti6),a
	ld	a,6
	ld	(pion),a
	JUMP_(mise_en_mem)
test5:
	ld	a,(sorti5)
	cp	1
	JUMP_Z(tirage)
	ld	a,1
	ld	(sorti5),a
	ld	a,5
	ld	(pion),a
	JUMP_(mise_en_mem)
test4:
	ld	a,(sorti4)
	cp	1
	JUMP_Z(tirage)
	ld	a,1
	ld	(sorti4),a
	ld	a,4
	ld	(pion),a
	JUMP_(mise_en_mem)
test3:
	ld	a,(sorti3)
	cp	1
	JUMP_Z(tirage)
	ld	a,1
	ld	(sorti3),a
	ld	a,3
	ld	(pion),a
	JUMP_(mise_en_mem)
test2:
	ld	a,(sorti2)
	cp	1
	JUMP_Z(tirage)
	ld	a,1
	ld	(sorti2),a
	ld	a,2
	ld	(pion),a
	JUMP_(mise_en_mem)
test1:
	ld	a,(sorti1)
	cp	1
	JUMP_Z(tirage)
	ld	a,1
	ld	(sorti1),a
	ld	a,1
	ld	(pion),a
	JUMP_(mise_en_mem)
test0:
	ld	a,(sorti0)
	cp	1
	JUMP_Z(tirage)
	ld	a,1
	ld	(sorti0),a
	ld	a,0
	ld	(pion),a
mise_en_mem:			; nous voici donc  la phase de mise en mmoire
	ld	a,b			; on charge b en a
	cp	5			; on compare a  5
	jr	z,pour_pion1	; si a est gal  5 (ie on est au premier pion, car b dcompte de 5  0)
	cp	4			; sinon si jamais il tait gal  4, etc
	jr	z,pour_pion2
	cp	3
	jr	z,pour_pion3
	cp	2
	jr	z,pour_pion4
pour_pion5:				; pour le pion 5:
	ld	a,(pion)		; on charge en a la valeur de pion
	ld	(pion5),a		; on charge pion via a en pion5
	jr	fin_boucle		; va  la fin de la boucle
pour_pion4:				; etc...
	ld	a,(pion)
	ld	(pion4),a
	jr	fin_boucle
pour_pion3:
	ld	a,(pion)
	ld	(pion3),a
	jr	fin_boucle
pour_pion2:
	ld	a,(pion)
	ld	(pion2),a
	jr	fin_boucle
pour_pion1:
	ld	a,(pion)
	ld	(pion1),a
fin_boucle:				; voil la fin de cette boucle
	dec	b			; on dcrmente b
	JUMP_NZ(tirage)		; s'il n'est pas gal  0, on refait une boucle

saisir_nombres:			; voil, enfin tu vas pouvoir rentrer tes nombres !!
	ld	a,1			; charge 1
	ld	(temoin),a		; dans temoin
	ld	b,5			; initialise compteur b (utilis dans djnz ci-aprs)
loooooooop:				; anglissisme (amricanisme ici ;)) qui nettoie l'endroit des chiffres
	ld	a,-17			; charge -17
	ld	(pion),a		; dans pion
	CALL_(print)		; pour l'afficher (en fait on affiche ascii(-17+49)=' '
	djnz	loooooooop		; retourne  loooooooop tant que b<>0


	ld	a,0			; charge 0 dans a
	ld	(temoin),a		; nettoie temoin
	ld	(coche0),a		; nettoie tous les coches (logique l aussi..)
	ld	(coche1),a		; etc...
	ld	(coche2),a
	ld	(coche3),a
	ld	(coche4),a
	ld	(coche5),a
	ld	(coche6),a
	ld	(coche7),a
	ld	b,5			; charge le compteur  5 (5 touches  frapper)

touche_suivante:			; explicite
	call	GET_KEY		; attend une touche
	cp	55			; la compare  55 [MODE]
	JUMP_Z(fin_de_tout)	; sortie immdiate du programme
	cp	34			; 34 [1]
	JUMP_Z(traite_num0)	; traite le numro 1 (avec un '0' pour em***der le monde...)
	cp	26			; etc...
	JUMP_Z(traite_num1)
	cp	18
	JUMP_Z(traite_num2)
	cp	35
	JUMP_Z(traite_num3)
	cp	27
	JUMP_Z(traite_num4)
	cp	19
	JUMP_Z(traite_num5)
	cp	36
	JUMP_Z(traite_num6)
	cp	28
	JUMP_Z(traite_num7)
	cp	56			; compare la touche  56 [DEL]
	JUMP_Z(saisir_nombres)	; on n'a plus qu' retaper les nombres
	JUMP_(touche_suivante)	; si on n'a pas tap de touches ou que la touche tape n'a pas son
					; code ici, on retourne en haut
traite_num0:			; on traite le numro 1 (contrairement  ce qui tait initialement prvu
	ld	a,(coche0)		; d'une manire analogue  test0,
	cp	1			; on regarde si le numro a dj t choisi
	JUMP_Z(touche_suivante)	; si oui, on retourne au traitement des touches
	ld	a,1			; sinon
	ld	(coche0),a		; on met 1 pour dire qu'il a t choisi
	ld	a,0			; on met 0 dans pion
	ld	(pion),a		; puis
	JUMP_(mise_en_mem2)	; on le mmorise dans pion_joue(n)
traite_num1:			; idem, non ??
	ld	a,(coche1)
	cp	1
	JUMP_Z(touche_suivante)
	ld	a,1
	ld	(coche1),a
	ld	a,1
	ld	(pion),a
	JUMP_(mise_en_mem2)
traite_num2:
	ld	a,(coche2)
	cp	1
	JUMP_Z(touche_suivante)
	ld	a,1
	ld	(coche2),a
	ld	a,2
	ld	(pion),a
	JUMP_(mise_en_mem2)
traite_num3:
	ld	a,(coche3)
	cp	1
	JUMP_Z(touche_suivante)
	ld	a,1
	ld	(coche3),a
	ld	a,3
	ld	(pion),a
	JUMP_(mise_en_mem2)
traite_num4:
	ld	a,(coche4)
	cp	1
	JUMP_Z(touche_suivante)
	ld	a,1
	ld	(coche4),a
	ld	a,4
	ld	(pion),a
	JUMP_(mise_en_mem2)
traite_num5:
	ld	a,(coche5)
	cp	1
	JUMP_Z(touche_suivante)
	ld	a,1
	ld	(coche5),a
	ld	a,5
	ld	(pion),a
	JUMP_(mise_en_mem2)
traite_num6:
	ld	a,(coche6)
	cp	1
	JUMP_Z(touche_suivante)
	ld	a,1
	ld	(coche6),a
	ld	a,6
	ld	(pion),a
	JUMP_(mise_en_mem2)
traite_num7:
	ld	a,(coche7)
	cp	1
	JUMP_Z(touche_suivante)
	ld	a,1
	ld	(coche7),a
	ld	a,7
	ld	(pion),a

mise_en_mem2:
	CALL_(print)		; on l'affiche d'abord pour que tout a ait un sens.
	ld	a,b			; d'une manire analogue  celle de la mise en mmoire des nombres
	cp	5			; tirs au hasard...
	jr	z,for_pion1
	cp	4
	jr	z,for_pion2
	cp	3
	jr	z,for_pion3
	cp	2
	jr	z,for_pion4
for_pion5:
	ld	a,(pion)
	ld	(pion_joue5),a
	jr	fin_touches
for_pion4:
	ld	a,(pion)
	ld	(pion_joue4),a
	jr	fin_touches
for_pion3:
	ld	a,(pion)
	ld	(pion_joue3),a
	jr	fin_touches
for_pion2:
	ld	a,(pion)
	ld	(pion_joue2),a
	jr	fin_touches
for_pion1:
	ld	a,(pion)
	ld	(pion_joue1),a
fin_touches:			; fin de prise en compte des touches
	dec	b			; on va au chiffre suivant
	JUMP_NZ(touche_suivante)

traite_coul:			; traite le nombre de bonnes couleurs ou bons chiffres suivant que
	ld	b,0			; la personne aime les maths ou non.
	ld	a,(coche0)		; on met d'abord b  0, puis coche0 en h
	ld	h,a			;
	ld	a,(sorti0)		; on met ensuite sorti0 en a
	cp	h			; on compare a  h, donc sorti0  coche0
	jp	nz,next1		; s'ils ne sont pas gaux, va plus loin
	inc	b			; s'ils sont gaux, on incrmente b
next1:
	ld	a,(coche1)		; mme processus pour le numro 2, ie savoir si TI82 et l'utilisateur
	ld	h,a			; ont coch les mmes nombres
	ld	a,(sorti1)		; etc...
	cp	h
	jp	nz,next2
	inc	b
next2:
	ld	a,(coche2)
	ld	h,a
	ld	a,(sorti2)
	cp	h
	jp	nz,next3
	inc	b
next3:
	ld	a,(coche3)
	ld	h,a
	ld	a,(sorti3)
	cp	h
	jp	nz,next4
	inc	b
next4:
	ld	a,(coche4)
	ld	h,a
	ld	a,(sorti4)
	cp	h
	jp	nz,next5
	inc	b
next5:
	ld	a,(coche5)
	ld	h,a
	ld	a,(sorti5)
	cp	h
	jp	nz,next6
	inc	b
next6:
	ld	a,(coche6)
	ld	h,a
	ld	a,(sorti6)
	cp	h
	jp	nz,next7
	inc	b
next7:
	ld	a,(coche7)
	ld	h,a
	ld	a,(sorti7)
	cp	h
	jp	nz,next8
	inc	b

next8:				; b contient maintenant le nombre d'galits entre sorti(n) et coche(n)
	ld	a,b			; on compare b  8 (sorti0=coche0,...,sorti7=coche7)
	cp	8			; on a donc les 5 bons chiffres
	jr	z,coul5		; on va donc le mmoriser quelque part
	cp	6			; sinon on n'en a que 4
	jr	z,coul4		;
	cp	4			; que 3
	jr	z,coul3		;
coul2:				; que 2
	ld	a,2			; on charge alors 2 dans a
	jp	plus_loin		; et on va le mettre en mmoire plus loin, comme l'indique le label
coul3:				; pareil, ici on a donc 3 bonnes couleurs 
	ld	a,3			; etc...
	jp	plus_loin
coul4:
	ld	a,4
	jp	plus_loin
coul5:
	ld	a,5
plus_loin:				; on est ici plus loin (!!!!!!!!????????!!!!!!)
	ld	(bonne_coul),a	; on charge dans bonne_coul le a dfini prcedemment
	ld	b,a			; on rappelle en b a
	ld	a,67			; on met 67 dans trucaaffich (code ascii de 'C')
	ld	(trucaaffich),a	; 
ptite_boucle:			; on rpte pendant a fois=bonne_coul fois la boucle suivante
	ld	a,(bonne_coul)	; on rappelle en a bonne_coul
	CALL_(affich)		; on affiche un 'C'
	djnz	ptite_boucle	; dcrmente b et retourne  ptite boucle tant que b<>0

traite_ordre:			; traitement de l'ordre
	ld	b,0			; de la mme manire, on met b  0
	ld	a,(pion1)		; ici on va comparer pion1  pion_joue1, etc
	ld	h,a			;
	ld	a,(pion_joue1)	; compare donc les 2 nombres en question
	cp	h			;
	jp	nz,suiv1		; s'ils ne sont pas gaux on va  suiv1
	inc	b			; sinon on incrmente le "compteur d'galits" b
suiv1:				; etc...
	ld	a,(pion2)
	ld	h,a
	ld	a,(pion_joue2)
	cp	h
	jp	nz,suiv2
	inc	b
suiv2:
	ld	a,(pion3)
	ld	h,a
	ld	a,(pion_joue3)
	cp	h
	jp	nz,suiv3
	inc	b
suiv3:
	ld	a,(pion4)
	ld	h,a
	ld	a,(pion_joue4)
	cp	h
	jp	nz,suiv4
	inc	b
suiv4:
	ld	a,(pion5)
	ld	h,a
	ld	a,(pion_joue5)
	cp	h
	jp	nz,suiv6
	inc	b
suiv6:				; on affiche maintenant le nombre de bonnes places
	ld	a,b			; 
	ld	(bonne_place),a	;
	ld	b,a			; 
	cp	0			; s'il y a 0 galit, on va aprs la boucle sinon a foire
	jp	z,fin			; devine pourquoi : a affiche 256 'P'  l'cran
	ld	a,80			; code ascii du 'P'
	ld	(trucaaffich),a	;
ptite_boucle2:			; idem ci-dessus...
	ld	a,(bonne_place)
	CALL_(affich)
	djnz	ptite_boucle2

fin:					; nous voil  la fin
	ld	a,(compteur)	; on
	dec	a			; dcrmente
	ld	(compteur),a	; le compteur
	ld	a,(bonne_place)	; on teste s'il y a
	cp	5			; 5 bonnes places
	JUMP_Z(gagne)		; si oui, on va  gagne (ce serait dommage de refaire 1 tour !!!)
	ld	a,(compteur)	; on teste
	cp	0			; galement si c'est pas le dernier coup auquel cas on aurait perdu
	JUMP_NZ(saisir_nombres)	; sinon on retourne saisir les nombres

perdu:				; explicite
	ld	hl,$0003		; on met une position dans hl (x=$00, y=$03)
	ld	($800C),hl		; cette position on la met dans la position du curseur, en ($800C)
	ld	hl,msg_perdu	; on charge ensuite le message  afficher
	ROM_CALL(D_ZT_STR)	; puis on affiche
	ld	b,5			; on charge b  5
affcomb:				; on affiche la combinaison pour voir qu'il y avait une solution !!
	ld	a,b			; on appelle b dans a
	cp	5			; on compare a  5
	jp	nz,loin2		; si a<>5 on ne parle pas du pion 1 donc on va au numro suivant
	ld	a,(pion1)		; on met pion1 en a
	jp	loin			; on va plus loin
loin2:				; est-ce la peine de t'expliquer a ??
	cp	4			; etc...
	jp	nz,loin3
	ld	a,(pion2)
	jp	loin
loin3:
	cp	3
	jp	nz,loin4
	ld	a,(pion3)
	jp	loin
loin4:
	cp	2
	jp	nz,loin5
	ld	a,(pion4)
	jp	loin
loin5:
	cp	1
	jp	nz,loin
	ld	a,(pion5)
loin:					; nous v'l donc l
	ld	(trucaaffich),a	; on met la valeur du piont, alias a, dans trucaaffich
	CALL_(affcombi)		; on affiche la combinaison pendant
	djnz	affcomb		; 5 tours car b=5  ce moment

	CALL_(attendre)		; on attend...
fin_de_tout:			; la fin de la fin : qu'est-ce ?? la fin de Master Mind
	ret				; retourne dans Ash, le "gestionnaire d'assembleur" le plus sympa

gagne:				; on a gagn
	ld	hl,$0003		; x=$00, y=$03
	ld	($800C),hl		; 
	ld	hl,msg_gagne	; charge le message,
	ROM_CALL(D_ZT_STR)	; l'affiche
	CALL_(attendre)		; attend
	ret				; retourne dans Ash

affich:				; affiche un 'P' ou un 'C'
	or	a			; on rappelle a, car a+a=a
	sub	b			; a:=a-b
	ld	c,a			; c:=a
	sla	a			; a:=a*2  a=2c
	sla	a			; a:=a*2  a=4c
	add	a,c			; a:=a+c  a=5c
	add	a,c			; a:=a+c  a=6c
	add	a,47			; a:=a+47 a=6c+47
	ld	l,a			; l:=6c+47 en fait, soit la position x
	ld	a,(compteur)	; on met compteur en a
	ld	c,a			; en c
	sla	a			; de la mme manire
	sla	a			; ...
	add	a,c			;
	add	a,c			;
	sub	4			;
	ld	h,a			; h:=6c-4 soit la position y
	ld	($8215),hl		; on met le mot hl en ($8215), adresse du curseur graphique
	ld	a,(trucaaffich)	; on charge en a le truc  afficher
	ROM_CALL(M_CHARPUT)	; on affiche le caractre a
	ret				; retourne

affcombi:				; affiche une combinaison
	ld	a,15			; a:=15
	sub	b			; a:=15-b
	ld	h,a			; h:=a, yposition
	ld	l,4			; l:=4, xposition
	ld	($800C),hl		; on charge hl comme curseur
	ld	a,(trucaaffich)	; on met trucaaffich en a
	add	a,49			; on y ajoute 49 pour avoir le code ascii du caractre voulu
	ROM_CALL(TX_CHARPUT)	; affiche le caractre
	ret

print:				; affiche un nombre/espace
	ld	a,5			; oprations sur la position
	sub	b			;
	ld	c,a			;
	sla	a			;
	sla	a			;
	add	a,c			;
	add	a,c			;
	add	a,9			;
	ld	l,a			; l:=6c+9, abscisse
	ld	a,(compteur)	;
	ld	c,a			;
	sla	a			;
	sla	a			;
	add	a,c			;
	add	a,c			;
	sub	4			;
	ld	h,a			; h:=6c-4, ordonne
	ld	($8215),hl		;
	ld	a,(pion)		; valeur qu'il faudra afficher
	add	a,49			; on lui ajoute 49 pour avoir son code ascii
	ld	c,a			; on sauve a dans c
	ROM_CALL(M_CHARPUT)	; on affiche la valeur ou un espace
	ld	a,(temoin)		;
	cp	0			; si temoin=1, on a demand  afficher des espaces
	jp	z,pas_fin		; on affiche 2 espaces
	inc	l			; supplmentaires
	ld	($8215),hl		; pour pouvoir effacer correctement  l'cran
	ld	a,c			; les anciens chiffres
	ROM_CALL(M_CHARPUT)	; principe comprhensible je pense
	inc	l			;
	ld	($8215),hl		;
	ld	a,c			;
	ROM_CALL(M_CHARPUT)	;
pas_fin:
	ret

dessine_ecran:			; on dessine l'cran de jeu
	ld	d,6			; 1 ligne  6
	CALL_(prem_loop)		;
	ld	d,7			; 1 ligne  7
	CALL_(prem_loop)		; etc
	ld	d,13
	CALL_(prem_loop)
	ld	d,19
	CALL_(prem_loop)
	ld	d,25
	CALL_(prem_loop)
	ld	d,31
	CALL_(prem_loop)
	ld	d,37
	CALL_(prem_loop)
	ld	d,38
	CALL_(prem_loop)
	ROM_CALL(DISP_GRAPH)	; affiche l'cran graphique

met_le_decor:			; on place la dcoration sur l'cran, en le mettant
	ld	hl,decoration	; l'image dans hl puis en l'affichant avec putimage
	CALL_(putimage)

	ld	b,10			; on affiche les 10 lettres du bord gauche de l'cran
affich_rangs:			;
	ld	a,b			;
	sla	a			; processus similaire aux procdures prcdentes
	sla	a			;
	add	a,b			;
	add	a,b
	sub	4
	ld	l,1
	ld	h,a
	ld	($8215),hl
	ld	a,75			; pour avoir le code
	sub	b			; ascii de la lettre
	ROM_CALL(M_CHARPUT)
	djnz	affich_rangs	; ritre 10 fois

	ret

prem_loop:				; procdure qui affiche une ligne 
	ld	b,64			; on met b  64
	ld	c,0			; on met c, le complment  64 de b
sec_loop:				; boucle
	push	bc			; on sauvegarde bc
	ld	b,d			; on met d dans b
	push	de			; on sauvegarde de
	CALL_(putpixel)		; on affiche le pixel (b,c)
	pop	de			; on redonne  d et e leurs valeurs prcdentes
	pop	bc			;      "       b  " c           "
	inc	c			; on incrmente c
	djnz	sec_loop		; on dcrmente b jusqu' 0
	ret

Random:				; Cre un nombre au hasard x tq 0 <= x < A
	ld	a,8			; cette procdure fait comme un shaker
	push	bc			; Thanks to Jimmy Mrdell
	push	de
	push	hl
	ld	b,a
	ld	a,r
	add	a,a
	ld	hl,0
	ld	d,0
	ld	e,a
RMul:
	add	hl,de
	djnz	RMul
	ld	a,h
	pop	hl
	pop	de
	pop	bc
	ret				; fini ce "satan" shaker ;)

; MERCI A (THANKS TO) Jimmy Mrdell pour ces 2 routines :

putpixel:				; affiche un pixel (hl contient l'adresse du dessin)
	call	FIND_PIXEL		; donne l'tat du pixel (b,c)  l'cran
	ld	de,$88B8		; on charge en de la mmoire graphique
	add	hl,de			; on ajoute de  hl
	or	(hl)			; fait un OU entre (hl) et ce qu'il y a  l'cran
					; ("a" retourn par FIND_PIXEL) et le stocke en a
	ld	(hl),a		; on remet a en (hl)
	ret

putimage:				; affiche l'image stocke en hl
	ld	e,(hl)		; trucs assez techniques expliqus dans la leon n5 de Zshell Online
	inc	hl			; School de Jimmy Mrdell, disponible sur son site
	ld	d,(hl)		; toutefois si vous voulez je pourrai rpondre  vos questions => e-mail!
	inc	hl
	ld	b,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
pi_newrow:
	push	bc
	push	de
pi_newcol:
	ld	a,(hl)
	inc	hl
	ld	(de),a
	inc	de
	djnz	pi_newcol
	pop	de
	ld	bc,12
	ex	de,hl
	add	hl,bc
	ex	de,hl
	pop	bc
	dec	c
	jr	nz,pi_newrow
	ROM_CALL(DISP_GRAPH)
	ret

faire_defiler:			; faire dfiler l'image
	ld	b,64			; on met 64 dans b
defilement:				; 
	push	bc			; sauvegarde de bc
	ld	hl,GRAPH_MEM+12	; on charge la mmoire graphique+12 (dcale) en hl
	ld	de,GRAPH_MEM	; en de la mmoire graphique
	ld	bc,768		; nombre d'octets  copier
	ldir				; copie
	ld	a,0
	ld	de,GRAPH_MEM+756	; srie de trucs qui effacent une ligne noire en bas de l'cran
	ld	(de),a		; si quelqu'un sait faire autre chose, qu'il me le dise svp
	ld	de,GRAPH_MEM+757	; pareil...
	ld	(de),a
	ld	de,GRAPH_MEM+758
	ld	(de),a
	ld	de,GRAPH_MEM+759
	ld	(de),a
	ld	de,GRAPH_MEM+760
	ld	(de),a
	ld	de,GRAPH_MEM+761
	ld	(de),a
	ld	de,GRAPH_MEM+762
	ld	(de),a
	ld	de,GRAPH_MEM+763
	ld	(de),a
	ld	de,GRAPH_MEM+764
	ld	(de),a
	ld	de,GRAPH_MEM+765
	ld	(de),a
	ld	de,GRAPH_MEM+766
	ld	(de),a
	ld	de,GRAPH_MEM+767
	ld	(de),a
	ROM_CALL(DISP_GRAPH)
	pop bc			; restaure b et c
	djnz	defilement		; fait pendant 64 itrations, ie la taille de l'cran tu l'avais devin
	ret

attendre:				; attendre qu'une touche soit presse
	call	GET_KEY		; saisie d'une ventuelle touche frappe
	or	a			; on rappelle la valeur de a (a+a=a)
	jr	z,attendre		; si pas de touche frappe, re-attendre
	ret				; retourne si on a frapp une touche

; Donnes : les trucs bizarres sont des accents pour nous, les francophones

msg_gagne:
	.db	"Well done, won !",0

msg_perdu:
	.db	"You have lost ! "
	.db	" It was :       ",0
	.db	0

decoration:						; Bandeau MASTER MIND
	.dw	$88DA
	.db	2,60
	.db	%00000111,%11111100
	.db	%00000111,%11111100
	.db	%00000010,%00000100
	.db	%00000011,%11111100
	.db	%00000011,%11111100
	.db	%00000000,%00000000
	.db	%00000011,%11111100
	.db	%00000011,%11111100
	.db	%00000010,%00000000
	.db	%00000011,%11111100
	.db	%00000011,%11111100
	.db	%00000000,%00000000
	.db	%00000101,%11111100
	.db	%00000101,%11111100
	.db	%00000000,%00000000
	.db	%00000111,%11111100
	.db	%00000111,%11111100
	.db	%00000111,%00000000
	.db	%00000000,%11111100
	.db	%00000111,%11111100
	.db	%00000111,%00000000
	.db	%00000111,%11111100
	.db	%00000111,%11111100
	.db	%00000000,%00000000
	.db	%00000000,%00000000
	.db	%00000000,%00000000
	.db	%00000011,%00000000
	.db	%00000011,%11111100
	.db	%00000011,%11111100
	.db	%00000000,%00000000
	.db	%00000001,%11011000
	.db	%00000011,%11011100
	.db	%00000010,%01000100
	.db	%00000011,%11111100
	.db	%00000001,%11111000
	.db	%00000000,%00000000
	.db	%00000001,%00000100
	.db	%00000111,%11111100
	.db	%00000111,%11111100
	.db	%00000000,%00000000
	.db	%00000011,%00111000
	.db	%00000011,%01111100
	.db	%00000010,%01100100
	.db	%00000011,%11101100
	.db	%00000001,%11001100
	.db	%00000000,%00000000
	.db	%00000001,%11111100
	.db	%00000011,%11111100
	.db	%00000010,%01000100
	.db	%00000011,%10111100
	.db	%00000001,%10111100
	.db	%00000000,%00000000
	.db	%00000111,%11111100
	.db	%00000111,%11111100
	.db	%00000111,%00000000
	.db	%00000000,%11111100
	.db	%00000111,%11111100
	.db	%00000111,%00000000
	.db	%00000111,%11111100
	.db	%00000111,%11111100




title_pic:					; Que quelqu'un essaie de dcrypter cela
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$07,$03,$C0,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$1C,$1E,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$7C,$7C,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$D1,$F8,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$01,$B9,$B8,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$01,$B3,$70,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$03,$73,$70,$00,$00,$0E,$00,$00,$00,$00
	.db	$00,$00,$06,$76,$E0,$00,$00,$1C,$00,$00,$00,$00
	.db	$00,$00,$06,$6C,$E0,$FE,$38,$7F,$3C,$3F,$00,$00
	.db	$00,$00,$0C,$F8,$C1,$9C,$6C,$38,$6C,$3E,$00,$00
	.db	$00,$00,$0C,$F9,$CF,$18,$FC,$F1,$F8,$F6,$60,$00
	.db	$00,$00,$18,$F1,$9E,$39,$F1,$E3,$E1,$E7,$C0,$00
	.db	$00,$00,$19,$E3,$BE,$33,$F3,$C7,$03,$E0,$00,$00
	.db	$00,$00,$31,$C3,$6C,$67,$B7,$CF,$0F,$C0,$00,$00
	.db	$00,$06,$61,$86,$CD,$EF,$3D,$BB,$39,$80,$00,$00
	.db	$00,$07,$C3,$3F,$8F,$79,$F9,$E1,$E3,$80,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$0E,$07,$80,$00,$00,$38,$00,$00
	.db	$00,$00,$00,$00,$38,$3C,$00,$00,$00,$70,$00,$00
	.db	$00,$00,$00,$00,$F8,$F8,$00,$00,$00,$60,$00,$00
	.db	$00,$00,$00,$01,$B1,$F0,$00,$00,$00,$E0,$00,$00
	.db	$00,$00,$00,$03,$73,$70,$E0,$00,$01,$C0,$00,$00
	.db	$00,$00,$00,$03,$66,$E0,$E0,$00,$01,$80,$00,$00
	.db	$00,$00,$00,$06,$E6,$E0,$00,$00,$03,$80,$00,$00
	.db	$00,$00,$00,$0C,$ED,$C0,$00,$00,$03,$00,$00,$00
	.db	$00,$00,$00,$0C,$D9,$C1,$87,$F0,$7E,$00,$00,$00
	.db	$00,$00,$00,$19,$F1,$83,$8F,$B1,$CE,$00,$00,$00
	.db	$00,$00,$00,$19,$F3,$9F,$3C,$67,$8C,$C0,$00,$00
	.db	$00,$00,$00,$31,$E3,$36,$78,$EE,$19,$80,$00,$00
	.db	$00,$00,$00,$33,$C7,$6E,$F8,$DE,$3B,$00,$00,$00
	.db	$00,$00,$00,$63,$86,$DD,$B1,$BC,$76,$00,$00,$00
	.db	$00,$00,$0C,$C3,$0D,$9B,$73,$EC,$FC,$00,$00,$00
	.db	$00,$00,$0F,$86,$7F,$1E,$E1,$CF,$B8,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	.db	$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db	$A0,$04,$50,$02,$00,$11,$00,$00,$04,$20,$00,$01
	.db	$A0,$06,$40,$02,$00,$11,$00,$00,$04,$00,$00,$01
	.db	$A9,$46,$52,$32,$E3,$11,$72,$94,$65,$24,$54,$99
	.db	$B5,$45,$55,$4A,$14,$1F,$0B,$5A,$96,$AA,$B4,$A5
	.db	$A4,$84,$D4,$4A,$F3,$11,$7A,$52,$F4,$A8,$94,$BD
	.db	$B4,$84,$D5,$4A,$91,$11,$4A,$52,$86,$AA,$B5,$A1
	.db	$A8,$84,$53,$32,$F6,$11,$7A,$52,$75,$26,$52,$9D
	.db	$80,$80,$00,$00,$00,$00,$00,$00,$00,$00,$10,$01
	.db	$81,$00,$00,$00,$00,$00,$00,$00,$00,$00,$10,$01
	.db	$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	.db	$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$20
	.db	$04,$00,$40,$00,$00,$21,$1C,$40,$01,$00,$C0,$20
	.db	$04,$20,$40,$00,$00,$20,$22,$00,$01,$00,$84,$20
	.db	$04,$CA,$5B,$94,$A3,$29,$4D,$55,$8F,$B1,$EB,$20
	.db	$05,$0D,$68,$5A,$D4,$B5,$55,$5A,$51,$48,$B0,$A0
	.db	$04,$C9,$4B,$D2,$97,$A5,$55,$53,$CD,$78,$A3,$20
	.db	$04,$29,$4A,$52,$94,$35,$55,$52,$05,$40,$A4,$20
	.db	$04,$09,$4B,$D2,$93,$A9,$4E,$51,$D9,$BA,$A0,$20
	.db	$04,$00,$00,$00,$00,$00,$21,$00,$00,$00,$00,$20
	.db	$04,$00,$00,$00,$00,$00,$1E,$00,$00,$00,$00,$20
	.db	$04,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$20
	.db	$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$E0

	.end
	.end			; l pourquoi un 2 fin ?? Une question  personne, car personne ne sait